



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unity3D 为什么保存Transform等引用效率会更高</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unity3D 为什么保存Transform等引用效率会更高</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 11:54:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>正常来说，大部分同学一般get transform都直接gameobject.transform使用。但往往，你会发现有些人会将transform引用保存起来，例如：</p>
<div>&nbsp;</div>
<div>private Transform myTransform;</div>
<div>void Awake() {</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;myTransform = transform;</div>
<div>}</div>
<div>&nbsp;</div>
<div>然后使用myTransform替代this.transform。如果你不知道u3d内部实现获取方式你肯定会以为这人脑抽水了，有直接的不用，还自己保存起来。</div>
<div>&nbsp;</div>
<div>this.transform并不是变量，而是一个get/set属性（property）。</div>
<div>&nbsp;</div>
<div>
<div>using System;</div>
<div>using System.Runtime.CompilerServices;</div>
<div>using UnityEngineInternal;</div>
<div>namespace UnityEngine</div>
<div>{</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;public class Component : Object</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;{</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;public extern Transform transform</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[WrapperlessIcall]</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[MethodImpl(MethodImplOptions.InternalCall)]</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;get;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;}</div>
<div>}</div>
</div>
<div>&nbsp;</div>
<div>调用this.transform实际上是一个调用intenal method的过程（这是用C/C++写的，不是MONO的）。值得注意的是这个调用方法略慢，因为你需要调用外部的CIL（aka interop），花费了额外的性能。</div>
<div>&nbsp;</div>
<div>估计大概的效率（没测试，以后有时间再弄，大家可以参考下文章最后的链接）：</div>
<div>&nbsp;</div>
<div>GetComponent是this.transform的10倍消耗时间。</div>
<div>this.transform是保存了引用myTransform的1.5倍的消耗时间。(因为新版优化了不少)</div>
<div>&nbsp;</div>
<div>实际上：</div>
<div>&nbsp;</div>
<div>如果你是偶尔调用一下transform的话，那就不要保留它的引用了，直接this.transform。</div>
<div>&nbsp;</div>
<div>如果是Update中，每一帧都要改变的话，还是保留一下this.transform的引用吧。毕竟倘若一大堆东西的话，能快不少呢。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>原文如下：</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>I have a question from this Burgzerg tutorial&nbsp;<a href="http://www.youtube.com/watch?v=O8-oZfi4utY" rel="external nofollow noreferrer">http://www.youtube.com/watch?v=O8-oZfi4utY</a></p>
<p>I don't understand why Pete says to cache the transform by defining the myTransform variable at the top of the script and then assigning it a transform value in the Awake() function like as follows:</p>
<div>
<div>Code (csharp):</div>
<div>
<ol><li><div>// Putting transform into variable</div></li>
<li><div>&nbsp; &nbsp;&nbsp;private&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Transform" rel="external nofollow noreferrer">Transform</a>&nbsp;myTransform;</div></li>
<li><div>&nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;// This is called before anything else in script is called</div></li>
<li><div>&nbsp; &nbsp;&nbsp;void&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Awake" rel="external nofollow noreferrer">Awake</a>()&nbsp;{</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;// Caching transform</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp; myTransform&nbsp;=&nbsp;transform;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;}</div></li></ol>
</div>
</div>
<p>I understand that Awake() is called before anything else in the entire script but how does that help cache the transform of the object that this script is attached to? Why not just use Update() to constantly make calls to the object's transform? After all, the transform is most likely going to be constantly changing.</p>
<p>The full code from the video is below:</p>

<div>
<div>Code (csharp):</div>
<div>
<ol><li><div>using&nbsp;UnityEngine;</div></li>
<li><div>using&nbsp;System.Collections;</div></li>
<li><div>&nbsp;</div></li>
<li><div>public&nbsp;class&nbsp;EnemyAI&nbsp;:&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=MonoBehaviour" rel="external nofollow noreferrer">MonoBehaviour</a>&nbsp;{</div></li>
<li><div>&nbsp; &nbsp;&nbsp;public&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Transform" rel="external nofollow noreferrer">Transform</a>&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=target" rel="external nofollow noreferrer">target</a>;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;public&nbsp;int&nbsp;moveSpeed;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;public&nbsp;int&nbsp;rotationSpeed;</div></li>
<li><div>&nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;// Putting transform into variable</div></li>
<li><div>&nbsp; &nbsp;&nbsp;private&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Transform" rel="external nofollow noreferrer">Transform</a>&nbsp;myTransform;</div></li>
<li><div>&nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;// This is called before anything else in script is called</div></li>
<li><div>&nbsp; &nbsp;&nbsp;void&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Awake" rel="external nofollow noreferrer">Awake</a>()&nbsp;{</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;// Caching transform</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp; myTransform&nbsp;=&nbsp;transform;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;}</div></li>
<li><div>&nbsp;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;// Use this for initialization</div></li>
<li><div>&nbsp; &nbsp;&nbsp;void&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Start" rel="external nofollow noreferrer">Start</a>&nbsp;()&nbsp;{</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=GameObject" rel="external nofollow noreferrer">GameObject</a>&nbsp;go&nbsp;=&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=GameObject" rel="external nofollow noreferrer">GameObject</a>.FindGameObjectWithTag("Player");</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=target" rel="external nofollow noreferrer">target</a>&nbsp;=&nbsp;go.transform;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;}</div></li>
<li><div>&nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp;&nbsp;// Update is called once per frame</div></li>
<li><div>&nbsp; &nbsp;&nbsp;void&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Update" rel="external nofollow noreferrer">Update</a>&nbsp;()&nbsp;{</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Debug" rel="external nofollow noreferrer">Debug</a>.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=DrawLine" rel="external nofollow noreferrer">DrawLine</a>(<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=target" rel="external nofollow noreferrer">target</a>.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=position" rel="external nofollow noreferrer">position</a>, myTransform.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=position" rel="external nofollow noreferrer">position</a>,&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Color" rel="external nofollow noreferrer">Color</a>.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=yellow" rel="external nofollow noreferrer">yellow</a>);&nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;// Look at target (player)</div></li>
<li><div>&nbsp; &nbsp; &nbsp; &nbsp; myTransform.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=rotation" rel="external nofollow noreferrer">rotation</a>&nbsp;=&nbsp;<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Quaternion" rel="external nofollow noreferrer">Quaternion</a>.<a href="http://unity3d.com/support/documentation/ScriptReference/30_search.html?q=Slerp" rel="external nofollow noreferrer">Slerp</a></div></li>
<li><div>&nbsp; &nbsp;&nbsp;}</div></li>
<li><div>}</div></li></ol>
</div>
</div>
</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq14xw0q.html">gdnz</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2lw78.html">百度地图API使用方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nn63q.html">Dom终</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93l47g9.html">Redis集群的部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xx37e8.html">openstack 排错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewzd79.html">activiti自定义流程之Spring整合activiti-modeler5&period;16实例（一）：环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okv2v59.html">第三百三十五天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgxzp9.html">VB程序逆向反汇编常见的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdem0l8.html">再探CRC</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwrmd9.html">Select &ast; 一定不走索引是否正确？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdzx69.html">PHP 静态缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey7z0j9.html">Android实时直播，一千行java搞定不依赖jni，延迟0&period;8至3秒，强悍移动端来袭</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp7rdzq.html">学习使人快乐8--Maven</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3y779.html">qemu创建vm和vcpu进入kvm的流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1n7309.html">python 之模块random</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyl5yd9.html">20145203盖泽双 《网络对抗技术》实践九：Web安全基础实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7y7gq.html">sublime text3 license</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyw3w39.html">2019 flag</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vdm55q.html">SpringBoot&lpar;四&rpar;&lowbar;Spring Data JPA的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emx76z9.html">【AtCoder】ARC095 E - Symmetric Grid 模拟</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qwnneyq.html">HTML5中的 Canvas</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8myy5r8.html">【转】COM技术内幕（笔记）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qng46g8.html">经典排序算法&lpar;PHP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvjomoq.html">Unity粒子系统特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96lk1y9.html">sass中级语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jv6049.html">解剖SQLSERVER 第十四篇    Vardecimals 存储格式揭秘（译）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96l2349.html">Xml文件并发读写的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z6pv3q.html">Xamarin&period;Forms&period;Platform&period;Perspex&comma; Xamarin Forms 的 Perspex&lpar;号称下一代WPF&rpar; 实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qngew38.html">ASP&period;NET 开发必备知识点&lpar;1&rpar;：如何让Asp&period;net网站运行在自定义的Web服务器上</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y3x0q.html">onCreateView中加载大位图</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
